#ifndef _ASM_POWERPC_FPU_API_H
#define _ASM_POWERPC_FPU_API_H

#include <linux/sched.h>
#include <asm/switch_to.h>
#include <asm/cputable.h>
#include <linux/uaccess.h>

static inline void kernel_fpu_begin(void)
{
	if (cpu_has_feature(CPU_FTR_VSX_COMP)) {
		preempt_disable();
		enable_kernel_vsx();
	} else if (cpu_has_feature(CPU_FTR_ALTIVEC_COMP)) {
		preempt_disable();
		enable_kernel_altivec();
	} else if (!cpu_has_feature(CPU_FTR_FPU_UNAVAILABLE)) {
		preempt_disable();
		enable_kernel_fp();
	}
}


static inline void kernel_fpu_end(void)
{
	if (cpu_has_feature(CPU_FTR_VSX_COMP)) {
		disable_kernel_vsx();
		preempt_enable();
	} else if (cpu_has_feature(CPU_FTR_ALTIVEC_COMP)) {
		disable_kernel_altivec();
		preempt_enable();
	} else if (!cpu_has_feature(CPU_FTR_FPU_UNAVAILABLE)) {
		disable_kernel_fp();
		preempt_enable();
	}
}

#endif /* _ASM_POWERPC_FPU_API_H */
