/* SPDX-License-Identifier: GPL-2.0+ */
#include <linux/types.h>

/*
 * may_use_simd - whether it is allowable at this time to issue SIMD
 *                instructions or access the SIMD register file
 *
 * It's always ok in process context (ie "not interrupt")
 * but it is sometimes ok even from an irq.
 */
#ifdef CONFIG_PPC_FPU
extern bool may_use_simd(void);
#else
static inline bool may_use_simd(void)
{
	return false;
}
#endif
